/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gprobocode.func;

import ec.*;
import ec.gp.*;
import ec.util.*;

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

public class Progn3 extends GPNode {

    public String toString() {
        return "Progn3";
    }

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {
        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 3)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        // Evaluate all children.  Easy as cake.
        children[0].eval(state, thread, input, stack, individual, problem);
        children[1].eval(state, thread, input, stack, individual, problem);
        children[2].eval(state, thread, input, stack, individual, problem);
    }

}



