/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gprobocode.func;

import java.util.Vector;

import ec.*;
import ec.gp.*;
import ec.util.*;

import gprobocode.*;

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

public abstract class BasicIf extends GPNode implements Constants {

    public abstract String toString();

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 2)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        if (condition((GPRobocode) problem, (GPRobocodeData) input)) {
            children[0].eval(state, thread, input, stack, individual,
                             problem);
        }
        else {
            children[1].eval(state, thread, input, stack, individual,
                             problem);
        }
    }

    protected abstract boolean condition(GPRobocode gprobocode,
                                         GPRobocodeData input);

    public static boolean findEventType(Vector events, Class type) {

        for (int i = 0; i < events.size(); i++) {
            if (type.isInstance(events.elementAt(i))) {
                return true;
            }
        }

        return false;
    }
}

